/* Tabela ITEMRETI: Item de Retirada */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela ITEMRETI */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela ITEMRETI,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_PLA_ITEMRETI
AFTER DELETE OR INSERT OR UPDATE
ON ITEMRETI FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(500);
  V_DTOPER    DATE;
  V_CDARVPROD VARCHAR2(20);
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDARVPROD := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN
      V_DESC := V_DESC || 'Fili=' || :OLD.CDFILIAL;
      V_DESC := V_DESC || ' Card=' || :OLD.NRCARDAPIO;
      V_DESC := V_DESC || ' Reti=' || :OLD.NRRETIRADA;
      SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
      V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
      IF (NVL(:OLD.CDTIPORETI, '') <> '') THEN
         V_DESC := V_DESC || ' TipoReti=' || :OLD.CDTIPORETI;
      END IF;
      IF (NVL(:OLD.CDTIPOPRAT, '') <> '') THEN
         V_DESC := V_DESC || ' TipoPrat=' || :OLD.CDTIPOPRAT;
      END IF;
      IF (NVL(:OLD.CDFILAUXPRAT, '') <> '') THEN
         V_DESC := V_DESC || ' Arv=' || :OLD.CDFILAUXPRAT;
      END IF;
      IF (NVL(:OLD.CDPRATO, '') <> '') THEN
         V_DESC := V_DESC || ' Prato=' || :OLD.CDPRATO;
      END IF;
      IF (NVL(:OLD.QTPREVISRETI, -1) <> -1) THEN
         V_DESC := V_DESC || ' Prev=' || TRIM(TO_CHAR(ROUND(:OLD.QTPREVISRETI, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:OLD.QTEXTRARETI, -1) <> -1) THEN
         V_DESC := V_DESC || ' Extra=' || TRIM(TO_CHAR(ROUND(:OLD.QTEXTRARETI, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:OLD.QTDEVOLVRETI, -1) <> -1) THEN
         V_DESC := V_DESC || ' Dev=' || TRIM(TO_CHAR(ROUND(:OLD.QTDEVOLVRETI, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:OLD.QTRETIRADA, -1) <> -1) THEN
         V_DESC := V_DESC || ' Cons=' || TRIM(TO_CHAR(ROUND(:OLD.QTRETIRADA, 5), '9999999990.00000'));
      END IF;
      IF (NVL(:OLD.CDFIITLANEST, '') <> '') THEN
         V_DESC := V_DESC || ' FiliLan=' || :OLD.CDFIITLANEST;
      END IF;
      IF (NVL(:OLD.NRLANCESTQ, '') <> '') THEN
         V_DESC := V_DESC || ' Lanto=' || :OLD.NRLANCESTQ;
      END IF;
      IF (NVL(:OLD.NRSEQUITEM, '') <> '') THEN
         V_DESC := V_DESC || ' Seq=' || :OLD.NRSEQUITEM;
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
      V_TIPO := '3';
      V_ITPESQ := :OLD.CDFILIAL||:OLD.NRCARDAPIO||:OLD.NRRETIRADA||V_CDARVPROD;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIAL   <> :NEW.CDFILIAL   ) OR
            (:OLD.NRCARDAPIO <> :NEW.NRCARDAPIO ) OR
            (:OLD.NRRETIRADA <> :NEW.NRRETIRADA ) OR
            (:OLD.CDPRODUTO  <> :NEW.CDPRODUTO  ) OR
            (NVL(:OLD.CDTIPORETI,   '') <> NVL(:NEW.CDTIPORETI,   '')) OR
            (NVL(:OLD.CDTIPOPRAT,   '') <> NVL(:NEW.CDTIPOPRAT,   '')) OR
            (NVL(:OLD.CDFILAUXPRAT, '') <> NVL(:NEW.CDFILAUXPRAT, '')) OR
            (NVL(:OLD.CDPRATO,      '') <> NVL(:NEW.CDPRATO,      '')) OR
            (NVL(:OLD.QTPREVISRETI,  -1) <> NVL(:NEW.QTPREVISRETI,  -1)) OR
            (NVL(:OLD.QTEXTRARETI,   -1) <> NVL(:NEW.QTEXTRARETI,   -1)) OR
            (NVL(:OLD.QTDEVOLVRETI,  -1) <> NVL(:NEW.QTDEVOLVRETI,  -1)) OR
            (NVL(:OLD.QTRETIRADA,    -1) <> NVL(:NEW.QTRETIRADA,    -1)) OR
            (NVL(:OLD.CDFIITLANEST, '') <> NVL(:NEW.CDFIITLANEST, '')) OR
            (NVL(:OLD.NRLANCESTQ,   '') <> NVL(:NEW.NRLANCESTQ,   '')) OR
            (NVL(:OLD.NRSEQUITEM,   '') <> NVL(:NEW.NRSEQUITEM,   '')) THEN
            V_TIPO   := '2';
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_ITPESQ := :OLD.CDFILIAL||:OLD.NRCARDAPIO||:OLD.NRRETIRADA||V_CDARVPROD;
         END IF;
      ELSE
         V_TIPO   := '1';
         SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
         V_ITPESQ := :NEW.CDFILIAL||:NEW.NRCARDAPIO||:NEW.NRRETIRADA||V_CDARVPROD;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDFILIAL <> :NEW.CDFILIAL) THEN
            V_DESC := V_DESC || 'Fili=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
         ELSE
            V_DESC := V_DESC || 'Fili=' || :OLD.CDFILIAL;
         END IF;
      ELSE
         V_DESC := V_DESC || 'Fili=' || :NEW.CDFILIAL;
      END IF;
      IF UPDATING THEN
         IF (:OLD.NRCARDAPIO <> :NEW.NRCARDAPIO) THEN
            V_DESC := V_DESC || ' Card=' || :OLD.NRCARDAPIO || '|' || :NEW.NRCARDAPIO;
         ELSE
            V_DESC := V_DESC || ' Card=' || :OLD.NRCARDAPIO;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Card=' || :NEW.NRCARDAPIO;
      END IF;
      IF UPDATING THEN
         IF (:OLD.NRRETIRADA <> :NEW.NRRETIRADA) THEN
            V_DESC := V_DESC || ' Reti=' || :OLD.NRRETIRADA || '|' || :NEW.NRRETIRADA;
         ELSE
            V_DESC := V_DESC || ' Reti=' || :OLD.NRRETIRADA;
         END IF;
      ELSE
         V_DESC := V_DESC || ' Reti=' || :NEW.NRRETIRADA;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDPRODUTO <> :NEW.CDPRODUTO) THEN
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :OLD.CDPRODUTO;
            V_DESC := V_DESC || ' Prod de=' || V_CDARVPROD;
            V_CDARVPROD := '';
            SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
            V_DESC := V_DESC || ' para=' || V_CDARVPROD;
         END IF;
      ELSE
         SELECT CDARVPROD INTO V_CDARVPROD FROM PRODUTO WHERE CDPRODUTO = :NEW.CDPRODUTO;
         V_DESC := V_DESC || ' Prod=' || V_CDARVPROD;
      END IF;
      IF (NVL(:NEW.CDTIPORETI, '') <> '') OR (UPDATING AND (NVL(:NEW.CDTIPORETI, '') = '')) THEN
         IF UPDATING THEN
            IF NVL(:OLD.CDTIPORETI, '') <> NVL(:NEW.CDTIPORETI, '') THEN
               V_DESC := V_DESC || ' TipoReti de=' || :OLD.CDTIPORETI || ' para=' || :NEW.CDTIPORETI;
            END IF;
         ELSE
            V_DESC := V_DESC || ' TipoReti=' || :NEW.CDTIPORETI;
         END IF;
      END IF;
      IF (NVL(:NEW.CDTIPOPRAT, '') <> '') OR (UPDATING AND (NVL(:NEW.CDTIPOPRAT, '') = '')) THEN
         IF UPDATING THEN
            IF NVL(:OLD.CDTIPOPRAT, '') <> NVL(:NEW.CDTIPOPRAT, '') THEN
               V_DESC := V_DESC || ' TipoPrat de=' || :OLD.CDTIPOPRAT || ' para=' || :NEW.CDTIPOPRAT;
            END IF;
         ELSE
            V_DESC := V_DESC || ' TipoPrat=' || :NEW.CDTIPOPRAT;
         END IF;
      END IF;
      IF (NVL(:NEW.CDFILAUXPRAT, '') <> '') OR (UPDATING AND (NVL(:NEW.CDTIPOPRAT, '') = '')) THEN
         IF UPDATING THEN
            IF NVL(:OLD.CDFILAUXPRAT, '') <> NVL(:NEW.CDFILAUXPRAT, '') THEN
               V_DESC := V_DESC || ' Arv de=' || :OLD.CDFILAUXPRAT || ' para=' || :NEW.CDFILAUXPRAT;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Arv=' || :NEW.CDFILAUXPRAT;
         END IF;
      END IF;
      IF (NVL(:NEW.CDPRATO, '') <> '') OR (UPDATING AND (NVL(:NEW.CDPRATO, '') = '')) THEN
         IF UPDATING THEN
            IF NVL(:OLD.CDPRATO, '') <> NVL(:NEW.CDPRATO, '') THEN
               V_DESC := V_DESC || ' Prato de=' || :OLD.CDPRATO || ' para=' || :NEW.CDPRATO;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Prato=' || :NEW.CDPRATO;
         END IF;
      END IF;
      IF (NVL(:NEW.QTPREVISRETI, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTPREVISRETI, -1) = -1)) THEN
         IF UPDATING THEN
            IF NVL(:OLD.QTPREVISRETI, -1) <> NVL(:NEW.QTPREVISRETI, -1) THEN
               V_DESC := V_DESC || ' Prev de=' || TRIM(TO_CHAR(ROUND(:OLD.QTPREVISRETI, 5), '9999999990.00000')) || ' para='                          || TRIM(TO_CHAR(ROUND(:NEW.QTPREVISRETI, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' Prev=' || TRIM(TO_CHAR(ROUND(:NEW.QTPREVISRETI, 5), '9999999990.00000'));
         END IF;
      END IF;
      IF (NVL(:NEW.QTEXTRARETI, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTEXTRARETI, -1) = -1)) THEN
         IF UPDATING THEN
            IF NVL(:OLD.QTEXTRARETI, -1) <> NVL(:NEW.QTEXTRARETI, -1) THEN
               V_DESC := V_DESC || ' Extra de=' || TRIM(TO_CHAR(ROUND(:OLD.QTEXTRARETI, 5), '9999999990.00000')) || ' para='                          || TRIM(TO_CHAR(ROUND(:NEW.QTEXTRARETI, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' Extra=' || TRIM(TO_CHAR(ROUND(:NEW.QTEXTRARETI, 5), '9999999990.00000'));
         END IF;
      END IF;
      IF (NVL(:NEW.QTDEVOLVRETI, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTDEVOLVRETI, -1) = -1)) THEN
         IF UPDATING THEN
            IF NVL(:OLD.QTDEVOLVRETI, -1) <> NVL(:NEW.QTDEVOLVRETI, -1) THEN
               V_DESC := V_DESC || ' Dev de=' || TRIM(TO_CHAR(ROUND(:OLD.QTDEVOLVRETI, 5), '9999999990.00000')) || ' para='                          || TRIM(TO_CHAR(ROUND(:NEW.QTDEVOLVRETI, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' Dev=' || TRIM(TO_CHAR(ROUND(:NEW.QTDEVOLVRETI, 5), '9999999990.00000'));
         END IF;
      END IF;
      IF (NVL(:NEW.QTRETIRADA, -1) <> -1) OR (UPDATING AND (NVL(:NEW.QTRETIRADA, -1) = -1)) THEN
         IF UPDATING THEN
            IF NVL(:OLD.QTRETIRADA, -1) <> NVL(:NEW.QTRETIRADA, -1) THEN
               V_DESC := V_DESC || ' Cons de=' || TRIM(TO_CHAR(ROUND(:OLD.QTRETIRADA, 5), '9999999990.00000')) || ' para=' 
                         || TRIM(TO_CHAR(ROUND(:NEW.QTRETIRADA, 5), '9999999990.00000'));
            END IF;
         ELSE
            V_DESC := V_DESC || ' Cons=' || TRIM(TO_CHAR(ROUND(:NEW.QTRETIRADA, 5), '9999999990.00000'));
         END IF;
      END IF;
      IF (NVL(:NEW.CDFIITLANEST, '') <> '') OR (UPDATING AND (NVL(:NEW.CDFIITLANEST, '') = '')) THEN
         IF UPDATING THEN
            IF NVL(:OLD.CDFIITLANEST, '') <> NVL(:NEW.CDFIITLANEST, '') THEN
               V_DESC := V_DESC || ' FiliLan de=' || :OLD.CDFIITLANEST || ' para=' || :NEW.CDFIITLANEST;
            END IF;
         ELSE
            V_DESC := V_DESC || ' FiliLan=' || :NEW.CDFIITLANEST;
         END IF;
      END IF;
      IF (NVL(:NEW.NRLANCESTQ, '') <> '') OR (UPDATING AND (NVL(:NEW.NRLANCESTQ, '') = '')) THEN
         IF UPDATING THEN
            IF NVL(:OLD.NRLANCESTQ, '') <> NVL(:NEW.NRLANCESTQ, '') THEN
               V_DESC := V_DESC || ' Lanto de=' || :OLD.NRLANCESTQ || ' para=' || :NEW.NRLANCESTQ;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Lanto=' || :NEW.NRLANCESTQ;
         END IF;
      END IF;
      IF (NVL(:NEW.NRSEQUITEM, '') <> '') OR (UPDATING AND (NVL(:NEW.NRSEQUITEM, '') = '')) THEN
         IF UPDATING THEN
            IF NVL(:OLD.NRSEQUITEM, '') <> NVL(:NEW.NRSEQUITEM, '') THEN
               V_DESC := V_DESC || ' Seq de=' || :OLD.NRSEQUITEM || ' para=' || :NEW.NRSEQUITEM;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Seq=' || :NEW.NRSEQUITEM;
         END IF;
      END IF;
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('ITEMRETI', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_PLA_ITEMRETI','5.07.000'); END;
/

